-- =============================================
-- Author		: Rahmat Setiawan (Arkamaya)
-- Create date	: 17 September 2013
-- Description	: Taking Data From ICS Finished Create PO
-- =============================================
CREATE PROCEDURE [dbo].[SP_ICS_InsertPostingFilePO_Goldy]
	@processId BIGINT
AS
BEGIN
	SET NOCOUNT ON;
	
	DECLARE @sqlQuery AS VARCHAR(MAX),
			@rowIndex AS INT,
			@rowCount AS INT,
			@newRowId AS INT;
	
    CREATE TABLE #ICS_FINISH
	(
		ROW_ID BIGINT,
		PO_NO VARCHAR(30),
		PRODUCTION_MONTH VARCHAR(6),
		DOCK_CD VARCHAR(3),
		SUPPLIER_CD VARCHAR(6),
		CURRENCY_CD VARCHAR(3),
		EXCHANGE_RATE NUMERIC,
		TOTAL_AMOUNT NUMERIC,
		SUPPLIER_PLANT CHAR(4),
		CREATED_BY VARCHAR(20),
		PO_ITEM VARCHAR(5),
        PR_NO VARCHAR(8),
        PR_ITEM VARCHAR(5),
        MAT_NO VARCHAR(23),
        SOURCE_TYPE VARCHAR(1),
        PROD_PURPOSE_CD VARCHAR(5),
        PLANT_CD VARCHAR(4),
        SLOC_CD nchar(10),
        PART_COLOR_SUFFIX VARCHAR(2),
        PACKING_TYPE VARCHAR(1),
        PO_QTY_ORIGINAL INT,
        PO_MAT_PRICE NUMERIC,
        REQUIRED_DT DATETIME, 
		PO_DATE DATETIME,
		ERR_CD VARCHAR(20),
		ERR_MESSAGE VARCHAR(MAX)
	)	
	
	CREATE TABLE #ICS_FINISH_SUCESS
	(
		ROW_ID BIGINT,
		PO_NO VARCHAR(30),
		PRODUCTION_MONTH VARCHAR(6),
		SUPPLIER_CD VARCHAR(6),
		CURRENCY_CD VARCHAR(3),
		EXCHANGE_RATE NUMERIC,
		TOTAL_AMOUNT NUMERIC,
		SUPPLIER_PLANT CHAR(4),
		CREATED_BY VARCHAR(20),
		PO_ITEM VARCHAR(5),
        PR_NO VARCHAR(8),
        PR_ITEM VARCHAR(5),
        MAT_NO VARCHAR(23),
        SOURCE_TYPE VARCHAR(1),
        PROD_PURPOSE_CD VARCHAR(5),
        PLANT_CD VARCHAR(4),
        SLOC_CD nchar(10),
        PART_COLOR_SUFFIX VARCHAR(2),
        PACKING_TYPE VARCHAR(1),
        PO_QTY_ORIGINAL INT,
        PO_MAT_PRICE NUMERIC,
        REQUIRED_DT DATETIME, 
		PO_DATE DATETIME,
	)
	
	SET @sqlQuery = 'INSERT INTO #ICS_FINISH_SUCESS SELECT * FROM OPENQUERY([IPPCS_TO_ICS] , ''SELECT rownum, b.* FROM (SELECT DISTINCT a.PO_NO, a.PROD_MONTH, a.SUPP_CD, a.PO_CURR, a.PO_EXCHANGE_RATE, a.QTY_N * a.PO_MAT_PRICE AS TOTAL_AMOUNT, NULL AS SUPPLIER_PLANT, ''''System'''' AS CREATED_BY, 
	   a.PO_ITEM_NO, a.PR_NO, a.PR_ITEM, a.MAT_NO, a.SOURCE_TYPE, a.PROD_PURPOSE_CD, a.PLANT_CD, a.SLOC_CD, a.PART_COLOR_SFX, a.PACKING_TYPE, a.PO_QUANTITY_ORIGINAL, 
	   a.PO_MAT_PRICE, NULL AS REQUIRED_DT, a.DOC_DT AS PO_DATE FROM QAICU001.TB_R_FINISHED_CREATE_PO a ) b WHERE b.PO_NO IS NOT NULL'')';
	EXEC (@sqlQuery);
    
    SELECT @rowCount = COUNT(*) FROM #ICS_FINISH_SUCESS;
	SELECT @rowIndex = 1;
	
	WHILE @rowIndex <= @rowCount
	BEGIN
		---=== INSERT INTO PO_H
			IF NOT EXISTS(SELECT 1 FROM TB_R_PO_H WHERE PO_NO IN (SELECT PO_NO FROM #ICS_FINISH))
			BEGIN
				INSERT INTO TB_R_PO_H (PO_NO, SUPPLIER_CD, PRODUCTION_MONTH, PO_DATE, PO_TYPE, SUPPLIER_PLANT, EXCHANGE_RATE, 
									   PO_CURR, TOTAL_AMOUNT, STATUS_CD, REQUIRED_DT, CREATED_BY, CREATED_DT)
				SELECT PO_NO, SUPPLIER_CD, PRODUCTION_MONTH, PO_DATE, '1', SUPPLIER_PLANT, EXCHANGE_RATE, 
									   CURRENCY_CD, TOTAL_AMOUNT, 10, REQUIRED_DT, CREATED_BY, GETDATE() FROM #ICS_FINISH_SUCESS WHERE ROW_ID = @rowIndex
			END
		
			---=== INSERT INTO PO_D
			INSERT INTO TB_R_PO_D (PO_NO, PO_ITEM, PR_NO, PR_ITEM, MAT_NO, SOURCE_TYPE, PROD_PURPOSE_CD, PLANT_CD, SLOC_CD, PART_COLOR_SUFFIX, PACKING_TYPE,
								   PO_QTY_ORIGINAL, PO_MAT_PRICE, REQUIRED_DT, CURRENCY_CD, AMOUNT, CREATED_BY, CREATED_DT 
			)
			SELECT PO_NO, PO_ITEM, PR_NO, PR_ITEM, MAT_NO, SOURCE_TYPE, PROD_PURPOSE_CD, PLANT_CD, SLOC_CD, PART_COLOR_SUFFIX, PACKING_TYPE,
								   PO_QTY_ORIGINAL, PO_MAT_PRICE, REQUIRED_DT, CURRENCY_CD, TOTAL_AMOUNT, CREATED_BY, GETDATE() FROM #ICS_FINISH_SUCESS WHERE ROW_ID = @rowIndex
		
			---=== INSERT INTO LOG TABLE
			--IF ((SELECT PART_COLOR_SUFFIX FROM #ICS_FINISH WHERE ROW_ID = @rowIndex) = '1')
			--BEGIN
			--	IF NOT EXISTS(SELECT * FROM TB_R_LOG_TRANSACTION_H WHERE PROCESS_ID = @processId
			--					AND MANIFEST_NO = (SELECT TOTAL_AMOUNT FROM #ICS_FINISH_SUCESS WHERE ROW_ID = @rowIndex))
			--	BEGIN
			--		--- INSERT LOG HEADER TABLE
			--		INSERT INTO TB_R_LOG_TRANSACTION_H ([PROCESS_ID], [PROCESS_ID_ICS], [MANIFEST_NO], [CREATED_BY], [CREATED_DATE], [CHANGED_BY], [CHANGED_DATE])
			--		VALUES (@processId, NULL, (SELECT TOTAL_AMOUNT FROM #ICS_FINISH_SUCESS WHERE ROW_ID = @rowIndex), 'System', GETDATE(), NULL, NULL)
									
			--		SET @newRowId = SCOPE_IDENTITY()
			--	END ELSE BEGIN
			--		SELECT @newRowId = LOG_ID_H FROM TB_R_LOG_TRANSACTION_H
			--		WHERE PROCESS_ID = @processId
			--				AND MANIFEST_NO = CAST((SELECT TOTAL_AMOUNT FROM #ICS_FINISH_SUCESS WHERE ROW_ID = @rowIndex) AS VARCHAR)
			--	END
				
			--	INSERT INTO TB_R_LOG_TRANSACTION_D ([LOG_ID_H], [SEQ_NO], [SYSTEM_SOURCE], [USR_ID], [MOVEMENT_TYPE], [PROCESS_DT], [POSTING_DT], [MANIFEST_NO], 
			--										[KANBAN_ORER_NO], [PROD_PURPOSE_CD], [SOURCE_TYPE], [PART_NO], [SUPP_CD], [DOCK_CD], [PLANT_CD], [SLOC_CD], 
			--										[LOCATION], [ERR_CD], [ERR_MESSAGE], [CREATED_BY], [CREATED_DT], [CHANGED_BY], [CHANGED_DT])
			--	SELECT ROW_ID, NULL, PO_NO, PRODUCTION_MONTH, SUPPLIER_CD, CURRENCY_CD, EXCHANGE_RATE, TOTAL_AMOUNT, SUPPLIER_PLANT, CREATED_BY, 
			--		   PO_ITEM, PR_NO, PR_ITEM , MAT_NO, SOURCE_TYPE, PROD_PURPOSE_CD, NULL, PACKING_TYPE, PO_MAT_PRICE, CREATED_BY, GETDATE(), NULL, NULL
			--	FROM #ICS_FINISH_SUCESS WHERE ROW_ID = @rowIndex
				
			--END
			
			SET @rowIndex = @rowIndex + 1;
    END
    
    SET @sqlQuery = 'INSERT INTO #ICS_FINISH SELECT * FROM OPENQUERY([IPPCS_TO_ICS] , ''SELECT rownum, b.* FROM (SELECT DISTINCT a.PO_NO, a.PROD_MONTH, a.DOCK_CD, a.SUPP_CD, a.PO_CURR, a.PO_EXCHANGE_RATE, a.QTY_N * a.PO_MAT_PRICE AS TOTAL_AMOUNT, NULL AS SUPPLIER_PLANT, ''''System'''' AS CREATED_BY, 
	   a.PO_ITEM_NO, a.PR_NO, a.PR_ITEM, a.MAT_NO, a.SOURCE_TYPE, a.PROD_PURPOSE_CD, a.PLANT_CD, a.SLOC_CD, a.PART_COLOR_SFX, a.PACKING_TYPE, a.PO_QUANTITY_ORIGINAL, 
	   a.PO_MAT_PRICE, NULL AS REQUIRED_DT, a.DOC_DT AS PO_DATE, a.ERR_CD, a.ERR_MSG FROM QAICU001.TB_R_FINISHED_CREATE_PO a ) b WHERE b.PO_NO IS NULL'')';
	EXEC (@sqlQuery);
    
    SELECT @rowCount = COUNT(*) FROM #ICS_FINISH;
	SELECT @rowIndex = 1;
	
	WHILE @rowIndex <= @rowCount
	BEGIN
			---=== INSERT LPOP CONFIRMATION ABNORMALITY LOG
			DECLARE
				@PROC_ID VARCHAR(12),
				@PROCESS_ID BIGINT,
				@LAST_PROCESS_ID VARCHAR(12),
				@TODAY VARCHAR(8),
				@NOW DATETIME,
				@CURR_NO INT,
				@CURR_PROCESS_ID VARCHAR(12),
				@LOG_ID_H BIGINT
				
			SELECT @TODAY = CONVERT(VARCHAR(8), GETDATE(), 112);

			--GET LAST PROCESS ID
			SELECT @LAST_PROCESS_ID = ISNULL(MAX(PROCESS_ID), '1') FROM TB_R_LOG_TRANSACTION_H
			WHERE SUBSTRING(CAST(PROCESS_ID AS VARCHAR(12)), 1, 8) = @TODAY;
			IF @LAST_PROCESS_ID = '1'
			BEGIN
				SELECT @CURR_NO = 1;
			END
			ELSE
			BEGIN
				SELECT @CURR_NO = CAST(SUBSTRING(@LAST_PROCESS_ID,9,LEN(@LAST_PROCESS_ID)) AS INT) + 1;
			END;

			--GET NEXT PROCESS ID
			SELECT @CURR_PROCESS_ID = RIGHT(REPLICATE('0', 4)+ CAST(@CURR_NO AS VARCHAR(4)), 4);
			SELECT @PROC_ID = @TODAY + @CURR_PROCESS_ID;
			SELECT @PROCESS_ID = CAST(@PROC_ID AS BIGINT);
			--SELECT @PROCESS_ID
			
			IF NOT EXISTS(SELECT 1 FROM TB_R_LOG_TRANSACTION_H WHERE PROCESS_ID = @processId)
			BEGIN
				INSERT INTO TB_R_LOG_TRANSACTION_H (PROCESS_ID, PROCESS_ID_ICS, MANIFEST_NO, CREATED_BY, CREATED_DATE)
				VALUES  (@processId , -- PROCESS_ID - bigint
						  CAST(@LAST_PROCESS_ID AS INT) , -- PROCESS_ID_ICS - int
						  '' , -- MANIFEST_NO - varchar(25)
						  (SELECT CREATED_BY FROM #ICS_FINISH WHERE ROW_ID = @rowIndex) , -- CREATED_BY - varchar(20)
						  GETDATE())
			END
				SELECT @LOG_ID_H=LOG_ID_H FROM TB_R_LOG_TRANSACTION_H WHERE PROCESS_ID = @processId
				
				INSERT INTO TB_R_LOG_TRANSACTION_D (LOG_ID_H, SEQ_NO, SYSTEM_SOURCE, USR_ID, MOVEMENT_TYPE, PROCESS_DT, POSTING_DT, MANIFEST_NO, 
													KANBAN_ORER_NO, PROD_PURPOSE_CD, SOURCE_TYPE, PACK_MONTH, D_ID, VERS, PART_NO, SUPP_CD, DOCK_CD, 
													PLANT_CD, SLOC_CD, LOCATION, ERR_MESSAGE, CREATED_BY, CREATED_DT)
				SELECT 
					  @LOG_ID_H , -- LOG_ID_H - bigint
					  @rowIndex , -- SEQ_NO - numeric
					  '' , -- SYSTEM_SOURCE - varchar(20)
					  '' , -- USR_ID - varchar(20)
					  '' , -- MOVEMENT_TYPE - varchar(4)
					  GETDATE() , -- PROCESS_DT - datetime
					  GETDATE() , -- POSTING_DT - datetime
					  '' , -- MANIFEST_NO - varchar(16)
					  '' , -- KANBAN_ORER_NO - varchar(16)
					  '' , -- PROD_PURPOSE_CD - varchar(5)
					  '' , -- SOURCE_TYPE - varchar(1)
					  PRODUCTION_MONTH,  -- PACK_MONTH
					  'FCST', -- D_ID
					  'F', -- VERS
					  MAT_NO , -- PART_NO - varchar(12)
					  SUPPLIER_CD , -- SUPP_CD - varchar(5)
					  DOCK_CD , -- DOCK_CD - varchar(6)
					  PLANT_CD , -- PLANT_CD - varchar(4)
					  SLOC_CD , -- SLOC_CD - varchar(6)
					  '' , -- LOCATION - varchar(100)
					  ERR_MESSAGE , -- ERR_MESSAGE - text
					  CREATED_BY , -- CREATED_BY - varchar(20)
					  GETDATE()
				FROM #ICS_FINISH WHERE ROW_ID = @rowIndex
		
			---=== INSERT LPOP CONFIRMATION ABNORMALITY
			DECLARE @PRODUCTION_MONTH VARCHAR(6) = (SELECT PRODUCTION_MONTH FROM #ICS_FINISH WHERE ROW_ID = @rowIndex),
					@PART_CD VARCHAR(12) = (SELECT MAT_NO FROM #ICS_FINISH WHERE ROW_ID = @rowIndex),
					@SUPP_CD VARCHAR(5) = (SELECT SUPPLIER_CD FROM #ICS_FINISH WHERE ROW_ID = @rowIndex),
					@ERR_CD VARCHAR(MAX) = (SELECT ERR_CD FROM #ICS_FINISH WHERE ROW_ID = @rowIndex),
					@CREATED_BY VARCHAR(20) = (SELECT CREATED_BY FROM #ICS_FINISH WHERE ROW_ID = @rowIndex)
			
			EXEC SP_InsertLPOPConfirmationAbnormality @PRODUCTION_MONTH, 'FCST', 'F', @PART_CD, @SUPP_CD, @ERR_CD
			
			SET @rowIndex = @rowIndex + 1;
				
		END
    
    ---=== UPDATE CREATE PO
    UPDATE TB_R_LPOP_CONFIRMATION SET 
		PO_CREATED_BY = @CREATED_BY, 
		PO_CREATED_DT = GETDATE(), 
		CHANGED_BY = @CREATED_BY, 
		CHANGED_DT = GETDATE() ,
		PO_CREATION_STATUS = '2'
	WHERE PRODUCTION_MONTH = @PRODUCTION_MONTH
    
END

